/*
 * PEMReader.java
 *
 * Created on January 10, 2002, 12:26 PM
 */

package ch.othello.openscep.internal;



import java.io.*;

import org.bouncycastle.asn1.*;
import org.bouncycastle.asn1.x509.*;
import org.bouncycastle.asn1.util.*;
import org.bouncycastle.asn1.pkcs.*;

import org.bouncycastle.util.test.*;
import org.bouncycastle.util.encoders.*;

/** Scep Client
 *
 * <pre>
 * $Id: PEMReader.java,v 1.7 2002/02/15 06:11:09 urut Exp $
 * $Log: PEMReader.java,v $
 * Revision 1.7  2002/02/15 06:11:09  urut
 * merge with alani
 * lots of mods for incorporating full support for HTTP communication with SCEPD; Httpd client is now capable of reading multipart-mime (sort of....??) messages
 *
 * Revision 1.6  2002/02/14 17:58:56  urut
 * syntax error removed
 *
 *
 * </pre>
 *
 * @since $Date: 2002/02/15 06:11:09 $
 * @author  urut
 * @version $Revision: 1.7 $
 */

public class PEMReader {

    /** Creates a new instance of PEMReader */
    public PEMReader() {
    }


    /** reads a PEM file and returns it as DERObject
     * @return DERObject (content of File)
     * @param filename PEM File with full path
     * @throws FileNotFoundException
     * @throws IOException
     */    
    public static DERObject readFile(String filename)  throws FileNotFoundException, IOException {
	String base64Input = new String();

	BufferedReader dStream = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
	
        while (dStream.ready()) {
		String line = dStream.readLine();

		if (!line.substring(1, 4).equals("---")) {
			base64Input += line;
		}
	}

        return ( decodeBase64DER(base64Input) );
        
        //byte[] bytes = org.bouncycastle.util.encoders.Base64.decode(base64Input);
        
        //byte[] bytes = Base64.decodeToByteArray( base64Input );
        //decodeToByteArray
        
        //return ( Utils.convertByteArrayToDERObject( bytes ) );
        
        //ByteArrayInputStream bIn = new ByteArrayInputStream(bytes);
	//DERInputStream dIn = new DERInputStream(bIn);
        //return ( dIn.readObject() );
     }

    public static DERObject readStream(InputStream in ) throws IOException {
	String base64Input = new String();
        
	BufferedReader dStream = new BufferedReader(new InputStreamReader( in ));
	
        while (dStream.ready()) {
		String line = dStream.readLine();

		if (!line.substring(1, 4).equals("---")) {
			base64Input += line;
		}
	}        
        
        return ( decodeBase64DER( base64Input) );
    }

    public static DERObject readString(String in ) throws IOException {
        byte[] bytes = org.bouncycastle.util.encoders.Base64.decode( in );
        return ( Utils.convertByteArrayToDERObject( bytes ) );
    }
    
    public static DERObject decodeBase64DER( String base64Input ) throws IOException {
        byte[] bytes = org.bouncycastle.util.encoders.Base64.decode(base64Input);
        return ( Utils.convertByteArrayToDERObject( bytes ) );
    }

    public static DERObject decodeBase64DER( byte[] base64Input ) throws IOException {
        byte[] bytes = org.bouncycastle.util.encoders.Base64.decode(base64Input);
        return ( Utils.convertByteArrayToDERObject( bytes ) );
    }

    public static byte[] removeLinefeeds(byte[] in) throws IOException {
        ByteArrayInputStream bin = new ByteArrayInputStream(in);
        BufferedReader dStream = new BufferedReader(new InputStreamReader( bin ));
                           
        String base64Input = "";
        while (dStream.ready()) {
		String line = dStream.readLine();
		base64Input += line;
	}        
        
        return ( base64Input.getBytes() );

    }
}
