package ch.othello.openscep.internal;

import java.math.BigInteger;
import java.security.SecureRandom;

import org.bouncycastle.crypto.AsymmetricBlockCipher;
import org.bouncycastle.crypto.AsymmetricCipherKeyPair;
import org.bouncycastle.crypto.params.RSAKeyParameters;
import org.bouncycastle.crypto.params.RSAPrivateCrtKeyParameters;
import org.bouncycastle.crypto.params.RSAKeyGenerationParameters;
import org.bouncycastle.crypto.engines.RSAEngine;
import org.bouncycastle.crypto.generators.RSAKeyPairGenerator;

import org.bouncycastle.crypto.CipherParameters;

import org.bouncycastle.util.encoders.Hex;


/** Generates RSA Keypair
 *  This Class is currently not in use
 *
 * <pre>
 * $Id: RSAKeyPairGen.java,v 1.3 2002/03/02 01:45:51 alani Exp $
 * $Log: RSAKeyPairGen.java,v $
 * Revision 1.3  2002/03/02 01:45:51  alani
 * comment, currently not used
 *
 * Revision 1.2  2002/01/08 21:00:29  urut
 * added javadoc header with cvs tags to every file
 *
 * </pre>
 *
 * @since $Date: 2002/03/02 01:45:51 $
 * @author  urut
 * @version $Revision: 1.3 $
  */

public class RSAKeyPairGen
{

    	private AsymmetricCipherKeyPair theKeyPair;

    	public void init()
    	{
		theKeyPair = generateKeyPair();
    	}

    	public BigInteger getPrivateModulus()
	{
		return (((RSAKeyParameters)theKeyPair.getPrivate()).getModulus()  );
	}
	
    	public BigInteger getPublicModulus()
	{
		return (((RSAKeyParameters)theKeyPair.getPublic()).getModulus()  );
	}

    	public BigInteger getPrivateExponent()
	{
		return (((RSAKeyParameters)theKeyPair.getPrivate()).getExponent()  );
	}

    	public BigInteger getPublicExponent()
	{
		return (((RSAKeyParameters)theKeyPair.getPublic()).getExponent()  );
	}

	public CipherParameters getPublicKey()
	{
		return ( ((RSAKeyParameters)theKeyPair.getPublic()) );
	}

	public RSAPrivateCrtKeyParameters getPrivateKey()
	{
		return ( ((RSAPrivateCrtKeyParameters)theKeyPair.getPrivate()) );
	}

    public AsymmetricCipherKeyPair generateKeyPair()
    {
        RSAKeyPairGenerator  pGen = new RSAKeyPairGenerator();
        RSAKeyGenerationParameters  genParam = new RSAKeyGenerationParameters(
                                            BigInteger.valueOf(0x11), new SecureRandom(), 1024, 10);  //should be 1024,25
						//certainty=80 for production
        pGen.init(genParam);

        AsymmetricCipherKeyPair  pair = pGen.generateKeyPair();
        
	System.out.println(  "Public modulus length: " + ((RSAKeyParameters)pair.getPublic()).getModulus().bitLength() );
	System.out.println(  "Public modulus : " + ((RSAKeyParameters)pair.getPublic()).getModulus().toString() );

	System.out.println(  "Public Exponent length: " +  ((RSAKeyParameters)pair.getPublic()).getExponent().bitLength() );

	System.out.println(  "Public Exponent : " +  ((RSAKeyParameters)pair.getPublic()).getExponent().toString() );


	System.out.println(  "Public isPrivate(): " + ((RSAKeyParameters)pair.getPublic()).isPrivate() );


	System.out.println(  "private modulus length: " + ((RSAKeyParameters)pair.getPrivate()).getModulus().bitLength() );
	System.out.println(  "private modulus : " + ((RSAKeyParameters)pair.getPrivate()).getModulus().toString() );


	System.out.println(  "private Exponent length: " +  ((RSAKeyParameters)pair.getPrivate()).getExponent().bitLength() );
	System.out.println(  "private Exponent : " +  ((RSAKeyParameters)pair.getPrivate()).getExponent().toString() );


	System.out.println(  "private isPrivate(): " + ((RSAKeyParameters)pair.getPrivate()).isPrivate() );


	return ( pair );
    }

   
}
