package ch.othello.openscep.internal.commands;

import java.io.IOException;

import ch.othello.openscep.ScepClient;
import ch.othello.openscep.ScepError;
import ch.othello.openscep.ScepPending;

/**
 * 
 * The Command Interface for the command pattern
 * 
 * <pre>
 * $Id: ScepCommand.java,v 1.7 2002/02/22 07:39:01 alani Exp $
 * $Log: ScepCommand.java,v $
 * Revision 1.7  2002/02/22 07:39:01  alani
 * added ScepError & ScepPending Exceptions
 *
 * Revision 1.6  2002/01/10 16:17:40  urut
 * fixed some bugs
 *
 * Revision 1.5  2002/01/10 15:09:38  alani
 * new attribute distinguishedName in ScepClient, scepReq now generates a transactionId
 *
 * Revision 1.3  2002/01/08 21:00:29  urut
 * added javadoc header with cvs tags to every file
 *
 * </pre>
 *
 * @since $Date: 2002/02/22 07:39:01 $
 * @version $Revision: 1.7 $
 * @author alani
 */
public interface ScepCommand {
	
	public boolean Assert(ScepClient theClient) throws IOException;
	public boolean Execute( ScepClient theClient ) throws IOException, ScepError, ScepPending;

}
