package ch.othello.openscep.servlet;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.StringReader;

import Acme.Serve.servlet.ServletOutputStream;
import Acme.Serve.servlet.http.HttpServletRequest;
import ch.othello.openscep.internal.Log;

/** Scep Http Servlet for a Netscape Certification Request 
 *
 * <pre>
 * $Id: MicrosoftRequestServlet.java,v 1.4 2002/02/24 23:59:00 alani Exp $
 * $Log: MicrosoftRequestServlet.java,v $
 * Revision 1.4  2002/02/24 23:59:00  alani
 * renamed functions sendHeader, sendFooter to sendFormXXX
 * was needed because of decorator functionality
 *
 * Revision 1.3  2002/02/24 22:23:40  alani
 * removed call to setCertReqOrig, not necessary anymore
 *
 * Revision 1.2  2002/02/23 23:02:33  alani
 * certificate enrollment for microsoft browsers
 * enrolls for the certificate but is not yet able
 * to import one
 *
 * Revision 1.1  2002/01/24 13:14:54  alani
 * wrote HttpClient
 *
 * </pre>
 *
 * @since $Date: 2002/02/24 23:59:00 $
 * @author  
 * @version $Revision: 1.4 $
 */


public class MicrosoftRequestServlet extends BasicRequestServlet {	

	public void sendFormHeader(ServletOutputStream p) throws IOException {
  		
		InputStream msh = getClass().getResourceAsStream( "vbscript.js" );
		
		BufferedReader in = new BufferedReader( new InputStreamReader(msh) );
		String line;
		while( (line = in.readLine()) != null ) {
			p.println( line );
		}
		in.close();
		
  		p.println("<object classid=\"clsid:43F8F289-7A20-11D0-8F06-00C04FC295E1\" codebase=\"file:///WINDOWS/SYSTEM/xenroll.dll\" id=\"cenroll\">");
		p.println("<p class=\"errmsg\">If you see this error message, read noting </p>");
		p.println("</object>");
		p.println("<CENTER>");
		p.println("<H2>" + res.getString("certificateEnrollment") + "</H2>");
		p.println("<form name=\"MyForm\" id=\"MyForm\" method=\"get\" action=\"/microsoft/request\">");
		
	}
	
	public void sendFormFooter(HttpServletRequest req, ServletOutputStream p)
		throws IOException {

		String challengePassword = req.getParameter("challenge");
		if ( challengePassword == null ) challengePassword = "";
	 	p.println("<input type=\"hidden\" name=\"challenge\" id=\"challenge\" value=\""+challengePassword+"\">");
        p.println("<label for=\"cspName\">Cryptographic Service Provider Name</label>");
		p.println("<select name=\"cspName\" id=\"cspName\">");
      	p.println("<option></option>");
    	p.println("</select>");
		p.println("<input type=\"button\" value=\"Submit\" onclick=\"myenroll.CreateP10()\">");
		p.println("<input type=\"hidden\" name=\"CERTREQ\" id=\"CERTREQ\" value=\"1234\">");
		p.println("<script type=\"text/vbscript\">");
		p.println("<!--");
  		p.println("Set myenroll=new Enroll");
		p.println("myenroll.FindProviders");
		p.println("-->");
		p.println("</script>");
		p.println("</form>");
		p.println("</center>");
	}
	
	protected void browserCertificateRequest(HttpServletRequest req) {

		String spkac = getParam(req, "CERTREQ");

		Log.debug(spkac);
		String base64Input = new String();
				
		// remove the linebreaks 
		BufferedReader dStream =
			new BufferedReader(new StringReader( spkac ));

		try {
			String line = dStream.readLine();
			while ( line != null ) {
				
				base64Input += line;
				line = dStream.readLine();
			}
		} catch(IOException e) {
			e.printStackTrace();
		}
		
		// set request type to PK10
		scep.setRequestType( scep.TYPE_PKCS10 );

		scep.setCertReq(base64Input);

	}	

}
